#version 300 es

uniform mat4 u_TransposeInvModel;
uniform mat4 u_Model;
uniform mat4 u_Palatte[50];
uniform mat4 u_VP;
uniform mediump sampler2D u_AmazDefaultWhiteTex;
uniform mat4 u_MVP;
uniform mat4 u_MV;
uniform mat4 u_View;
uniform mat4 u_InvView;
uniform mat4 u_Projection;
uniform mat4 u_TransposeMV;
uniform mat4 u_InvTransposeMV;
uniform mat4 u_InvModel;
uniform vec3 u_WorldSpaceCameraPos;
uniform vec4 u_ProjectionParams;
uniform vec4 u_ScreenParams;
uniform vec4 u_ZBufferParams;
uniform vec4 u_OrthoParams;
uniform mat4 u_CameraProjection;
uniform mat4 u_CameraInvProjection;
uniform vec4 u_CameraFrustumLeftPlane;
uniform vec4 u_CameraFrustumRightPlane;
uniform vec4 u_CameraFrustumBottomPlane;
uniform vec4 u_CameraFrustumTopPlane;
uniform vec4 u_CameraFrustumNearPlane;
uniform vec4 u_CameraFrustumFarPlane;
uniform vec4 u_Time;
uniform vec4 u_SinTime;
uniform vec4 u_CosTime;
uniform vec4 u_DeltaTime;

layout(location = 6) in vec4 attBoneIds;
layout(location = 7) in vec4 attWeights;
layout(location = 0) in vec3 attPosition;
layout(location = 1) in vec3 attNormal;
out vec3 v_posWS;
out vec3 v_nDirWS;
layout(location = 2) in vec3 attTangent;
out vec3 v_tDirWS;
out vec3 v_bDirWS;
out vec2 v_uv0;
layout(location = 3) in vec2 attTexcoord0;
out vec2 v_uv1;
layout(location = 4) in vec2 attTexcoord1;
out vec4 v_color;
layout(location = 5) in vec4 attColor;

vec4 objectToWorldNormal(vec4 objectNormal)
{
    return vec4(normalize((u_TransposeInvModel * objectNormal).xyz), objectNormal.w);
}

vec3 objectToWorldNormal(vec3 objectNormal)
{
    vec4 param = vec4(objectNormal, 0.0);
    return objectToWorldNormal(param).xyz;
}

vec3 objectToWorldDir(vec3 objectDir)
{
    return normalize(mat3(u_Model[0].xyz, u_Model[1].xyz, u_Model[2].xyz) * objectDir);
}

vec3 objectToWorldTangent(vec3 objectTangent)
{
    vec3 param = objectTangent;
    return objectToWorldDir(param);
}

void main()
{
    mat4 _94 = u_Palatte[int(attBoneIds.x)] * attWeights.x;
    mat4 _103 = u_Palatte[int(attBoneIds.y)] * attWeights.y;
    mat4 _116 = mat4(_94[0] + _103[0], _94[1] + _103[1], _94[2] + _103[2], _94[3] + _103[3]);
    mat4 _125 = u_Palatte[int(attBoneIds.z)] * attWeights.z;
    mat4 _138 = mat4(_116[0] + _125[0], _116[1] + _125[1], _116[2] + _125[2], _116[3] + _125[3]);
    mat4 _146 = u_Palatte[int(attBoneIds.w)] * attWeights.w;
    mat4 boneTransform = mat4(_138[0] + _146[0], _138[1] + _146[1], _138[2] + _146[2], _138[3] + _146[3]);
    vec3 bm_postiton = (boneTransform * vec4(attPosition, 1.0)).xyz;
    vec3 bn_normal = (boneTransform * vec4(attNormal, 0.0)).xyz;
    v_posWS = (u_Model * vec4(bm_postiton, 1.0)).xyz;
    vec3 param = bn_normal;
    v_nDirWS = objectToWorldNormal(param);
    vec3 bm_tangent = (boneTransform * vec4(attTangent, 0.0)).xyz;
    vec3 param_1 = bm_tangent;
    v_tDirWS = objectToWorldTangent(param_1);
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    v_uv0 = attTexcoord0;
    v_uv1 = attTexcoord1;
    v_color = attColor;
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    vec4 temp_temp_2 = u_VP * vec4(v_posWS, 1.0);
    gl_Position = temp_temp_2;
}

