#version 300 es

uniform mat4 u_TransposeInvModel;
uniform mat4 u_Model;
uniform mat4 u_MVP;
uniform mat4 u_VP;
uniform mediump sampler2D u_AmazDefaultWhiteTex;
uniform mat4 u_MV;
uniform mat4 u_View;
uniform mat4 u_InvView;
uniform mat4 u_Projection;
uniform mat4 u_TransposeMV;
uniform mat4 u_InvTransposeMV;
uniform mat4 u_InvModel;
uniform vec3 u_WorldSpaceCameraPos;
uniform vec4 u_ProjectionParams;
uniform vec4 u_ScreenParams;
uniform vec4 u_ZBufferParams;
uniform vec4 u_OrthoParams;
uniform mat4 u_CameraProjection;
uniform mat4 u_CameraInvProjection;
uniform vec4 u_CameraFrustumLeftPlane;
uniform vec4 u_CameraFrustumRightPlane;
uniform vec4 u_CameraFrustumBottomPlane;
uniform vec4 u_CameraFrustumTopPlane;
uniform vec4 u_CameraFrustumNearPlane;
uniform vec4 u_CameraFrustumFarPlane;
uniform vec4 u_Time;
uniform vec4 u_SinTime;
uniform vec4 u_CosTime;
uniform vec4 u_DeltaTime;

out vec2 v_uv0;
layout(location = 3) in vec2 attTexcoord0;
out vec2 v_uv1;
layout(location = 4) in vec2 attTexcoord1;
out vec3 v_posWS;
layout(location = 0) in vec3 attPosition;
out vec3 v_nDirWS;
layout(location = 1) in vec3 attNormal;
out vec3 v_tDirWS;
layout(location = 2) in vec3 attTangent;
out vec3 v_bDirWS;
out vec4 v_color;
layout(location = 5) in vec4 attColor;

vec4 objectToWorldNormal(vec4 objectNormal)
{
    return vec4(normalize((u_TransposeInvModel * objectNormal).xyz), objectNormal.w);
}

vec3 objectToWorldNormal(vec3 objectNormal)
{
    vec4 param = vec4(objectNormal, 0.0);
    return objectToWorldNormal(param).xyz;
}

vec3 objectToWorldDir(vec3 objectDir)
{
    return normalize(mat3(u_Model[0].xyz, u_Model[1].xyz, u_Model[2].xyz) * objectDir);
}

vec3 objectToWorldTangent(vec3 objectTangent)
{
    vec3 param = objectTangent;
    return objectToWorldDir(param);
}

void main()
{
    v_uv0 = attTexcoord0;
    v_uv1 = attTexcoord1;
    v_posWS = (u_Model * vec4(attPosition, 1.0)).xyz;
    mat4 temp_temp_1 = u_MVP;
    vec3 param = attNormal;
    v_nDirWS = objectToWorldNormal(param);
    vec3 param_1 = attTangent;
    v_tDirWS = objectToWorldTangent(param_1);
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    v_color = attColor;
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    vec4 temp_temp_2 = u_VP * vec4(v_posWS, 1.0);
    gl_Position = temp_temp_2;
}

